
'****************************************************************

'                              Atmega8A    RTC Ds1307

'                LCD  . Nokia-3310  Nokia-5110
'       BASCOM-AVR : 2.0.7.1; 2.0.7.3; 2.0.7.6; 2.0.7.7
'
'            "glcd-Nokia3310.lib"    LCD 
'
'                               (MrShilov)  2013
'
'            (Sasha_1973)  2013
'
'****************************************************************
'-------------------------------------------------------------------------------------------
  $regfile = "m8def.dat"                          '  
  $crystal = 1000000                              '   (    )' 2000000  ' 4000000  ' 8000000
  $framesize = 32
  $hwstack = 40
  $swstack = 16
  $baud = 4800                                    '1200     '2400     '4800     '9600     '19200     '38400     '57600     '115000
'----------------     ----------------------------------------
  $lib "mcsbyte.lbx"                              '      ,   ,     ,   
  $lib "ds1307clock.lib"                          '       , ,   
  $lib "glcd-Nokia3310.lib"                       '     LCD  .  Nokia-3310  Nokia-5110
'----------------   LCD Nokia3310  Nokia5110  -------------------
'           VDD -  +3,3,  LCD     2,6  5,8    ( !  !         LCD, !    LCD Nokia-3310  Nokia-5110 !)
'  Sclk = SCK -      SPI
'    Si  = SDIN -   SPI
'   A0  = D/C -           . 1  , 0  
'  Cs1 = SCE -  .    SCE        ,        ,      (   - "0")
'            GND -  
'            VOUT -   ,  ,        4.7uF,   ,     0,1
'  Rst  = RESET -        .   -
'-------------------------------------------------------------------------------------------
  Config Graphlcd = 128 * 64eadogm , Cs1 = Portd.4 , A0 = Portd.5 , Si = Portd.6 , Sclk = Portd.7 , Rst = Portd.3
  Const Negative_lcd = 0                          '    ,  "Negative_lcd = 1"
  Initlcd                                         '  LCD
  Cls                                             '  LCD
'----------------       LCD  ------------------

'  Glcdcmd 12                                      '   
'  Glcdcmd 13                                      '   
'  Glcdcmd 32                                      ' 
'  Glcdcmd 36                                      ' 

'---------------         ---------------
'  Setfont Font6x8
'  Setfont Font12x16dig
'-------------    TIMER2,    ( ) -----------------
'  Config Timer2 = Timer , Async = On , Prescale = 64       '  32768 / 64 / 256 = 0,5  ( TIMER2 = 2   )
'  Const __timer2 = 2
'---------------------------------------------------------------
  Config Timer2 = Timer , Async = On , Prescale = 128       '  32768 / 128 / 256 = 1  ( TIMER2 = 1   )
  Const __timer2 = 1        '      "__timer2"
'      TIMER2,   
  On Timer2 __timer2           'Nosave    '      TIMER2
'---------------       ---------------
'  Assr.3 = 1 : Waitms 100                         '  - AS2     
'      AS2 (3)   ASSR (ASSR.3),     "Powersave" -   .    TIMER2
'  Mcucr = &B10000000                              '      Power Idle
'  Mcucr = &B10110000                              '      Power Save
'----------------------------    i2c  -------------------------------
 Config Scl = Portc.5                             '    SCL
 Config Sda = Portc.4                             '    SDA
 Config I2cdelay = 1                              '  I2c 10 - 100 , 5 - 200 , 2 - 500 , 1 - 1  -         
 I2cinit                                          '   i2c
'--------------------     DS1307  ----------------------
 Const Ds1307_ = &HD0                       '    Ds1307
 Const Ds1307_ = &HD1                       '    Ds1307
'-------------------------------------------------------------------------------------------
'--------------     Ds1307 --------------------------
'-------------------------------------------------------------------------------------------
  Config Pind.2 = Input                           '    
  Config Int0 = Falling                           '        Rising ; Falling ; Low Level
'      INT0,   
  On Int0 __int0               '         Ds1307
'------------------------------   USART  -------------------------------------
  Config Pind.0 = Input                           '   RxD,  UART
  Config Pind.1 = Output                          '   TxD,  UART
'-----------------------     --------------------------------
  Dim  As Byte
  Dim  As Byte
  Dim  As Byte
  Dim  As Byte
  Dim  As Byte
  Dim Stop_ As Byte
  Dim Start_ As Byte
  Dim _ As Byte
  Dim _ As Byte
  Dim _string As String * 2
  Dim _ As Bit
  Dim _string As String * 2
  Dim _string As String * 2
  Dim __ds1307 As Byte
  Dim _sout_ds1307 As Byte
  Dim __ As Byte
  Dim __timer2 As Byte
  Dim ___ As Byte
  Dim ____usart As Byte
  Dim ___ As Byte
  Dim ___ As Byte
'-----------------------     -----------------------------
  Declare Sub _()
  Declare Sub __lcd()
  Declare Sub _()
  Declare Sub _uart()
  Declare Sub _ds1307()
  Declare Sub _()
  Declare Sub ___ds1307()
  Declare Sub __int0()
  Declare Sub __int1()
  Declare Sub __timer2()
  Declare Sub ___()
'------------------------     -----------------------------
  Gosub ___
  If _ = 1 Then Gosub ___ds1307
'!!!!!!!!!!       !!!!!!!!!!
'!!!!!!!!!!       !!!!!!!!!!
  Gosub _                              '!!!!!!!!!!       !!!!!!!!!!
'--------------------       --------------------
  Enable Int0                                     '     TIMER2,  
'  Enable Timer2                                   '     INT0,  
'--------------------       ------------------------
  Enable Interrupts
'-------------------------------------------------------------------------------------------
'****************************************************************
'------------------------------     -----------------------------------------
  Do
'-----------------------

      If __ds1307 = 1 Then Gosub _ds1307

      If __ = 1 Then Gosub __lcd

      If ____usart = 1 Then Gosub _uart

'-----------------------
    _:
      Power Idle
'-----------------------
  Loop
 End
'-------------------------------------------------------------------------------------------
'****************************************************************

'=================================================

'                                         

'=================================================

'=================================================
'           "SQW/OUT" Ds1307
'=================================================
  __int0:
'-------------------------------------------------------------------------------------------
    __ds1307 = 1
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'      INT1
'=================================================
  __int1:
'-------------------------------------------------------------------------------------------
'     ,  
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'----------------------     Ds1307  ------------------------
'=================================================
  _ds1307:
'-------------------------------------------------------------------------------------------
    I2cstart                                      '     I2c
    I2cwbyte Ds1307_                        '    Ds1307
    I2cwbyte &H00                                 '   
    I2cstart                                      '     I2c
    I2cwbyte Ds1307_                        '    Ds1307
    I2crbyte  , Ack                        '    (- )
    I2crbyte  , Ack                         '    (- )
    I2crbyte  , Ack                           '    (- )
    I2crbyte _ , Ack                    '     (- )
    I2crbyte _ , Ack                   '    (- )
    I2crbyte  , Ack                          '    (- )
    I2crbyte  , Nack                           '    (- )
    I2cstop                                       '   I2c
' ----------     Ds1307     ---------
     = Makedec()                    '   
     = Makedec()                      '   
     = Makedec()                          '   
    _ = Makedec(_)            '    
    _ = Makedec(_)          '   
     = Makedec()                        '   
     = Makedec()                            '   
'----------------       ----------------
    __ds1307 = 0                      '   _Ds1307
    __ = 1                   '  ,    
    ____usart = 1            '  ,     
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'        "SQW/OUT" Ds1307
'=================================================
  _:
'-------------------------------------------------------------------------------------------
    _sout_ds1307 = &B10010000           '     1   SQW/OUT - (    )
    I2cstart                                      '     I2c
    I2cwbyte Ds1307_                        '    Ds1307
    I2cwbyte 7                                    '   
    I2cwbyte _sout_ds1307               '  
    I2cstop                                       '   I2c
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'------------------      Ds1307  ----------------
'=================================================
  _:
'-------------------------------------------------------------------------------------------
    Stop_ = &B10000000                        '     
    I2cstart                                      '     I2c
    I2cwbyte Ds1307_                        '    Ds1307
    I2cwbyte 0                                    '   
    I2cwbyte Stop_                            '  
    I2cstop                                       '   I2c
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'------------------      Ds1307  -------------------
'=================================================
  _:
'-------------------------------------------------------------------------------------------
    Start_ = &B00000000                       '     
    I2cstart                                      '     I2c
    I2cwbyte Ds1307_                        '    Ds1307
    I2cwbyte 0                                    '   
    I2cwbyte Start_                           '  
    I2cstop                                       '   I2c
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'-----------        Ds1307  ------------
'=================================================
  ___ds1307:                       '     Ds1307
'-------------------------------------------------------------------------------------------
     = 0
     = 3
     = 1
    _ = 4
    _ = 14
     = 8
     = 13
    _sout_ds1307 = &B10010000           '     1  
    Start_ = &B00000000                       '  
'-------------------------------------
     = Makebcd()                    ' 
     = Makebcd()                      ' 
     = Makebcd()                          ' 
    _ = Makebcd(_)            '  
    _ = Makebcd(_)          ' 
     = Makebcd()                        ' 
     = Makebcd()                            ' 
'-------------------------------------
    I2cstart                                      '     I2c
    I2cwbyte Ds1307_                        '   
    I2cwbyte 0                                    '      - &H00
    I2cwbyte                               '   
    I2cwbyte                                '   
    I2cwbyte                                  '   
    I2cwbyte _                          '    
    I2cwbyte _                         '    
    I2cwbyte                                 '   
    I2cwbyte                                   '   
    I2cwbyte _sout_ds1307               '      SQW/OUT - (    )
    I2cwbyte Start_                           '  
    I2cstop                                       '   I2c
    Waitms 50
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'          
'=================================================
  ___:
'-------------------------------------------------------------------------------------------
    I2cstart
    I2cwbyte Ds1307_
    I2cwbyte &H00
    I2cstart
    I2cwbyte Ds1307_
    I2crbyte  , Nack
    I2cstop

    _ = .7
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'       LCD  . Nokia-3310  Nokia-5110
'=================================================
'-------------------------------------------------------------------------------------------
  __lcd:
'-------------------------------------------------------------------------------------------
    _string = Str()
    If  < 10 Then _string = " " + _string

    _string = Str()
    If  < 10 Then _string = "0" + _string

    _string = Str()
    If  < 10 Then _string = "0" + _string

    Setfont Font6x8
    Lcdat 1 , 1 , "   Ds1307 "
    Lcdat 4 , 70 , _string
    Lcdat 6 , 1 , "Nokia3310_5110"

    Setfont Font12x16dig
    Lcdat 3 , 5 , _string ; ":" ; _string       '; ":" ; 

    __ = 0
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'    TIMER2,  1  2   ,     TIMER2
'=================================================
  __timer2:
'-------------------------------------------------------------------------------------------
    Incr __timer2
    If __timer2 < __timer2 Then Goto __timer2

    __timer2 = 0
    __ds1307 = 1
'-----------------------------------
  __timer2:
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'---       ( USART)
'=================================================
  _uart:
'-------------------------------------------------------------------------------------------
    Print "  - " ;
    Print  ; ":" ;
    If  < 10 Then Print "0" ;
    Print  ; ":";
    If  < 10 Then Print "0" ;
    Print 
    Print ""

    ____usart = 0
'-------------------------------------------------------------------------------------------
  Return
'=================================================


'=================================================
'--------------------     ----------------------------------------
'=================================================
  $include "font6x8.font"
  $include "font12x16dig.font"
'=================================================